import ddf.minim.analysis.*;
import ddf.minim.*;


AudioPlayer song;
FFT fft;
BeatDetect beat;

void setup() {
  size (1024, 800);
  Minim.start(this);
  song = Minim.loadFile("NoCars.mp3");
  song.loop();
  fft = new FFT(song.mix.size(), 44100);
  beat = new BeatDetect();
}

void draw() {
  noStroke();
  fill(50, 20);
  rect(0, 0, width, height);
  noFill();
  stroke(255);
  fft.forward(song.mix);
  beat.detect(song.mix);
  for(int i = 0; i < fft.specSize(); i++) {
    noFill();
    //rect(i*2, height, 2, height - fft.getBand(i)*20);
    if (fft.getBand(i) > 60) {
      noStroke();
      fill(fft.getBand(i)/i, i, fft.getBand(i), 100);
      ellipse(i*40, random(height), fft.getBand(i) * 2, fft.getBand(i) * 2);
    }
    if (i > 4 && i < 40 && fft.getBand(i) > 60 && beat.isOnset()==false) {
      fill(random(200), random(200), random(200));
      beginShape(POLYGON);
      for(int j = 0; j <= random(10); j++){
          curveVertex(random(200,800), random(height));
      }
      endShape();
  }
    //println(i);
  }
}

void stop()
{
  // always close Minim audio classes when you finish with them
  song.close();
  super.stop();
}
